const callit = (fn, ...args) => {
  const options = {
    after: (t) => setTimeout(fn, t, ...args),
    every: (t) => setInterval(fn, t, ...args),
    beforeIO: () => process.nextTick(fn, ...args),
    afterIO: () => setImmediate(fn, ...args),
    now: () => fn(...args),
  }

  if (!args) options.with = (...args) => call(fn, ...args)

  return options
} 

module.exports = callit
